Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.commons.io.output
Class ByteArrayOutputStream

    java.lang.Object
      java.io.OutputStream
          org.apache.commons.io.output.ByteArrayOutputStream

All Implemented Interfaces:
  Closeable, Flushable

    public class ByteArrayOutputStream

extends OutputStream

This class implements an output stream in which the data is written into a byte array. The buffer automatically grows as data is written to it.

The data can be retrieved using `toByteArray()` and `toString()`.

Closing a `ByteArrayOutputStream` has no effect. The methods in this class can be called after the stream has been closed without generating an `IOException`.

This is an alternative implementation of the java.io.ByteArrayOutputStream class. The original implementation only allocates 32 bytes at the beginning. As this class is designed for heavy duty it starts at 1024 bytes. In contrast to the original it doesn't reallocate the whole memory block but allocates additional buffers. This way no buffers need to be garbage collected and the contents don't have to be copied to the new buffer. This class is designed to behave exactly like the original. The only exception is the deprecated toString(int) method that has been ignored.

Version:
  $Id: ByteArrayOutputStream.java 1021884 2010-10-12 18:49:16Z ggregory $
Author:
  Jeremias Maerki, Holger Hoffstatte

Constructor Summary
`ByteArrayOutputStream()` Creates a new byte array output stream.
`ByteArrayOutputStream(int size)` Creates a new byte array output stream, with a buffer capacity of the specified size, in bytes.

Method Summary
`void` | `close()` Closing a `ByteArrayOutputStream` has no effect.
`void` | `reset()`
`int` | `size()` Return the current size of the byte array.
`static InputStream` | `toBufferedInputStream(InputStream input)` Fetches entire contents of an `InputStream` and represent same data as result InputStream.
`byte[]` | `toByteArray()` Gets the curent contents of this byte stream as a byte array.
`String` | `toString()` Gets the curent contents of this byte stream as a string.
`String` | `toString(String enc)` Gets the curent contents of this byte stream as a string using the specified encoding.
`void` | `write(byte[] b, int off, int len)` Write the bytes to byte array.
`int` | `write(InputStream in)` Writes the entire contents of the specified input stream to this byte stream.
`void` | `write(int b)` Write a byte to byte array.
`void` | `writeTo(OutputStream out)` Writes the entire contents of this byte stream to the specified output stream.

Methods inherited from class java.io.OutputStream
`flush, write`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### ByteArrayOutputStream

    public ByteArrayOutputStream()

  Creates a new byte array output stream. The buffer capacity is initially 1024 bytes, though its size increases if necessary.

### ByteArrayOutputStream

    public ByteArrayOutputStream(int size)

  Creates a new byte array output stream, with a buffer capacity of the specified size, in bytes.

  Parameters:
    `size` - the initial size
  Throws:
    `IllegalArgumentException` - if size is negative

Method Detail

### write

    public void write(byte[] b,
                      int off,
                      int len)

  Write the bytes to byte array.

  Overrides:
    `write` in class `OutputStream`
  Parameters:
    `b` - the bytes to write
    `off` - The start offset
    `len` - The number of bytes to write

### write

    public void write(int b)

  Write a byte to byte array.

  Specified by:
    `write` in class `OutputStream`
  Parameters:
    `b` - the byte to write

### write

    public int write(InputStream in)
              throws IOException

  Writes the entire contents of the specified input stream to this byte stream. Bytes from the input stream are read directly into the internal buffers of this streams.

  Parameters:
    `in` - the input stream to read from
  Returns:
    total number of bytes read from the input stream (and written to this stream)
  Throws:
    `IOException` - if an I/O error occurs while reading the input stream
  Since:
    Commons IO 1.4

### size

    public int size()

  Return the current size of the byte array.

  Returns:
    the current size of the byte array

### close

    public void close()
               throws IOException

  Closing a `ByteArrayOutputStream` has no effect. The methods in this class can be called after the stream has been closed without generating an `IOException`.

  Specified by:
    `close` in interface `Closeable`
  Overrides:
    `close` in class `OutputStream`
  Throws:
    `IOException` - never (this method should not declare this exception but it has to now due to backwards compatability)

### reset

    public void reset()

  See Also:
    `ByteArrayOutputStream.reset()`

### writeTo

    public void writeTo(OutputStream out)
                 throws IOException

  Writes the entire contents of this byte stream to the specified output stream.

  Parameters:
    `out` - the output stream to write to
  Throws:
    `IOException` - if an I/O error occurs, such as if the stream is closed
  See Also:
    `ByteArrayOutputStream.writeTo(OutputStream)`

### toBufferedInputStream

    public static InputStream toBufferedInputStream(InputStream input)
                                             throws IOException

  Fetches entire contents of an `InputStream` and represent same data as result InputStream.

  This method is useful where,

  - Source InputStream is slow.
  - It has network resources associated, so we cannot keep it open for long time.
  - It has network timeout associated.
  It can be used in favor of `toByteArray()`, since it avoids unnecessary allocation and copy of byte[].
  This method buffers the input internally, so there is no need to use a `BufferedInputStream`.

  Parameters:
    `input` - Stream to be fully buffered.
  Returns:
    A fully buffered stream.
  Throws:
    `IOException` - if an I/O error occurs
  Since:
    Commons IO 2.0

### toByteArray

    public byte[] toByteArray()

  Gets the curent contents of this byte stream as a byte array. The result is independent of this stream.

  Returns:
    the current contents of this output stream, as a byte array
  See Also:
    `ByteArrayOutputStream.toByteArray()`

### toString

    public String toString()

  Gets the curent contents of this byte stream as a string.

  Overrides:
    `toString` in class `Object`
  Returns:
    the contents of the byte array as a String
  See Also:
    `ByteArrayOutputStream.toString()`

### toString

    public String toString(String enc)
                    throws UnsupportedEncodingException

  Gets the curent contents of this byte stream as a string using the specified encoding.

  Parameters:
    `enc` - the name of the character encoding
  Returns:
    the string converted from the byte array
  Throws:
    `UnsupportedEncodingException` - if the encoding is not supported
  See Also:
    `ByteArrayOutputStream.toString(String)`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2002-2010 The Apache Software Foundation. All Rights Reserved.